unit googletranslateform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure WebBrowser1DocumentComplete(ASender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure WebBrowser1DownloadComplete(Sender: TObject);
    procedure WebBrowser1NavigateComplete2(ASender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  idUri, strUtils;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  strUrl: string;
begin
  strUrl := Format (
    'http://translate.google.com/translate_t?hl=%s#%s|%s|%s',
    ['EN', 'EN', 'hi', 'Nothing here']);
  strUrl := TIdUri.URLEncode(strUrl);

  WebBrowser1.Navigate('http://translate.google.com/translate_t?hl=en#en|bg|nothing%20here');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  strHtml: string;
  nPosA, nPosB: Integer;
begin
  strHtml := WebBrowser1.OleObject.Document.DocumentElement.InnerHTML;
  nPosA := Pos ('id=result_box', strHtml); // open tag
  nPosA := PosEx ('>', strHtml, nPosA) + 1; // open tag end
  nPosB := PosEx ('<', strHtml, nPosA) - 1;
  Caption := Copy (strHtml, nPosA, nPosB - nPosA + 1);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Button2Click(nil);
  if Caption <> '' then
    Timer1.Enabled := False;
end;

procedure TForm1.WebBrowser1DocumentComplete(ASender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  // one: too early
end;

procedure TForm1.WebBrowser1DownloadComplete(Sender: TObject);
begin
  // two: way too early
  // Button2Click(nil);
end;

procedure TForm1.WebBrowser1NavigateComplete2(ASender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  Timer1.Enabled := True;
end;

end.
